VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Line Count"
   ClientHeight    =   4050
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4950
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4050
   ScaleWidth      =   4950
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox picHold 
      BorderStyle     =   0  'None
      Height          =   1455
      Left            =   135
      ScaleHeight     =   1455
      ScaleWidth      =   4650
      TabIndex        =   2
      Top             =   2430
      Width           =   4650
      Begin VB.CommandButton cmdClose 
         Caption         =   "&Close"
         Height          =   465
         Left            =   1530
         TabIndex        =   3
         Top             =   855
         Width           =   1455
      End
      Begin VB.Line Line3 
         X1              =   0
         X2              =   4635
         Y1              =   675
         Y2              =   675
      End
      Begin VB.Label lblTotalFiles 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "0"
         Height          =   195
         Left            =   4500
         TabIndex        =   7
         Top             =   405
         Width           =   90
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Total Files:"
         Height          =   195
         Left            =   90
         TabIndex        =   6
         Top             =   405
         Width           =   765
      End
      Begin VB.Line Line1 
         X1              =   0
         X2              =   4635
         Y1              =   15
         Y2              =   15
      End
      Begin VB.Label lblTotalCount 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "0"
         Height          =   195
         Left            =   4500
         TabIndex        =   5
         Top             =   90
         Width           =   90
      End
      Begin VB.Label lblTotalLineCount 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Total Line Count:"
         Height          =   195
         Left            =   90
         TabIndex        =   4
         Top             =   90
         Width           =   1215
      End
   End
   Begin VB.Line Line2 
      X1              =   90
      X2              =   4815
      Y1              =   360
      Y2              =   360
   End
   Begin VB.Label lblLineCount 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Line count"
      Height          =   195
      Index           =   0
      Left            =   3960
      TabIndex        =   1
      Top             =   135
      Width           =   750
   End
   Begin VB.Label lblDesc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Project Name"
      Height          =   195
      Index           =   0
      Left            =   90
      TabIndex        =   0
      Top             =   135
      Width           =   960
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Projects As New Collection
Dim FilesToRead As Collection

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Dim FL As Variant, PR As Variant, TotalLines As Long, ProjectLines As Long, MainProjectFile As String
    Dim FileName As String, MainPath As String, ProjectName As String, FileLines As Long, MaxWidth As Single
    Dim K As Integer, TotalFiles As Long
    
    FileName = LeftRange(Trim(Command), """", """")
    If FileName = "" Or ((Not LCase(FileName) Like "*.vbg") And (Not LCase(FileName) Like "*.vbp")) Then
        MsgBox "This file is not a Visual Basic Project or Project Group"
        DoEvents
        
        Unload Me
        Exit Sub
    End If
    
    Me.Show
    DoEvents
    
    MainPath = RightLeft(FileName, "\") & "\"
    If LCase(Right(FileName, 4)) = ".vbg" Then
        MainProjectFile = ReadProjectGroup(FileName)
    Else
        MainProjectFile = RightRight(FileName, "\", , ReturnEmptyStr)
        Projects.Add MainProjectFile
    End If
    
    DoEvents
    
    For Each PR In Projects
        Set FilesToRead = New Collection
        ProjectName = ReadProject(AbsPath(MainPath & PR))
        
        Load lblDesc(lblDesc.Count)
        lblDesc(lblDesc.UBound).Caption = LeftRange(ProjectName, """", """")
        lblDesc(lblDesc.UBound).Left = 90
        lblDesc(lblDesc.UBound).Top = lblDesc(lblDesc.UBound - 1).Top + lblDesc(lblDesc.UBound - 1).Height + 50
        lblDesc(lblDesc.UBound).Visible = True
        
        If PR = MainProjectFile Then
            If LCase(Right(FileName, 4)) = ".vbg" Then
                Me.Caption = "Line Count for Project Group " & ProjectName
            Else
                Me.Caption = "Line Count for Project " & ProjectName
            End If
        End If
        DoEvents
        
        ProjectLines = 0
        For Each FL In FilesToRead
            FileLines = CoutLines(FL)
            
            Load lblDesc(lblDesc.Count)
            lblDesc(lblDesc.UBound).Caption = FL
            lblDesc(lblDesc.UBound).Left = 400
            lblDesc(lblDesc.UBound).Top = lblDesc(lblDesc.UBound - 1).Top + lblDesc(lblDesc.UBound - 1).Height + 50
            lblDesc(lblDesc.UBound).Visible = True
            
            Load lblLineCount(lblLineCount.Count)
            lblLineCount(lblLineCount.UBound).Caption = FileLines
            lblLineCount(lblLineCount.UBound).Top = lblDesc(lblDesc.UBound).Top
            lblLineCount(lblLineCount.UBound).Left = lblDesc(lblDesc.UBound).Width + 600
            lblLineCount(lblLineCount.UBound).Visible = True
            
            If lblDesc(lblDesc.UBound).Width > MaxWidth Then MaxWidth = lblDesc(lblDesc.UBound).Width
            
            ProjectLines = ProjectLines + FileLines
            TotalLines = TotalLines + FileLines
            
            DoEvents
        Next FL
        
        TotalFiles = TotalFiles + FilesToRead.Count
        Set FilesToRead = Nothing
    Next PR
    
    Me.Width = MaxWidth + 1500
    Me.Height = lblDesc(lblDesc.UBound).Top + lblDesc(lblDesc.UBound).Height + picHold.Height + 700
    
    lblTotalCount.Caption = TotalLines
    For K = 0 To lblLineCount.UBound
        lblLineCount(K).Left = (Me.ScaleWidth - lblLineCount(K).Width) - 100
    Next K
    DoEvents
    
    lblTotalFiles.Caption = TotalFiles
    picHold_Resize
    
    Me.Show
End Sub

Public Function CoutLines(ByVal FileName As String) As Long
    Dim LN As String, Count As Long, PassHeader As Boolean
    
    Open FileName For Binary Access Read As #1
        Do Until Loc(1) >= LOF(1)
            Line Input #1, LN
            
            If Not PassHeader Then
                LN = Trim(LN)
                
                If LN Like "Attribute *" Then
                    PassHeader = False
                ElseIf (LN Like "Option Explicit") Or (LN Like "'*") Or (LN Like "Private *") Or _
                        (LN Like "Public *") Or (LN Like "Function *") Or (LN Like "Sub *") Or _
                        (LN Like "Const *") Or (LN Like "Type *") Or (LN Like "Declare *") Then
                    PassHeader = True
                End If
            Else
                Count = Count + 1
            End If
        Loop
    Close #1
    
    CoutLines = Count + 1
End Function

Public Function ReadProjectGroup(ByVal FileName As String) As String
    Dim LN As String, MainPath As String
    
    MainPath = RightLeft(FileName, "\", , ReturnOriginalStr) & "\"
    
    Open FileName For Binary Access Read As #1
        Do Until Loc(1) >= LOF(1)
            Line Input #1, LN
            
            If (LN Like "StartupProject=*") Then
                ReadProjectGroup = LeftRight(LN, "=")
                Projects.Add LeftRight(LN, "=")
            ElseIf LN Like "Project=*" Then
                Projects.Add LeftRight(LN, "=")
            End If
        Loop
    Close #1
End Function

Public Function ReadProject(ByVal FileName As String) As String
    Dim LN As String, MainPath As String
    
    MainPath = RightLeft(FileName, "\", , ReturnOriginalStr) & "\"
    
    Open FileName For Binary Access Read As #1
        Do Until Loc(1) >= LOF(1)
            Line Input #1, LN
            
            If (LN Like "Form=*") Or (LN Like "Module=*") Or (LN Like "Class=*") Or (LN Like "UserControl=*") Then
                If InStr(1, LN, ";") > 0 Then
                    If Dir(MainPath & LeftRight(LN, "; "), vbArchive + vbHidden + vbReadOnly) <> "" Then
                        FilesToRead.Add AbsPath(MainPath & LeftRight(LN, "; "))
                    End If
                ElseIf Dir(MainPath & LeftRight(LN, "="), vbArchive + vbHidden + vbReadOnly) <> "" Then
                    FilesToRead.Add AbsPath(MainPath & LeftRight(LN, "="))
                End If
            ElseIf LN Like "Name=*" Then
                ReadProject = LeftRight(LN, "=")
            End If
        Loop
    Close #1
End Function

Private Sub Form_Resize()
    picHold.Move 0, Me.ScaleHeight - picHold.Height, Me.ScaleWidth
    Line2.X1 = 100
    Line2.X2 = Me.ScaleWidth - 100
End Sub

Private Sub picHold_Resize()
    cmdClose.Left = (picHold.ScaleWidth / 2) - (cmdClose.Width / 2)
    
    lblTotalCount.Left = picHold.ScaleWidth - lblTotalCount.Width - 100
    lblTotalFiles.Left = picHold.ScaleWidth - lblTotalFiles.Width - 100
    
    Line1.X2 = picHold.ScaleWidth
    Line3.X2 = picHold.ScaleWidth
End Sub

Public Function AbsPath(ByVal FilePath As String) As String
    Dim K As Long, Q As Long
    
    FilePath = Replace(FilePath, "\.\", "\")
    
    K = InStr(1, FilePath, "\..\")
    If K > 0 Then
        Do Until K = 0
            Q = InStrRev(FilePath, "\", K - 1)
            FilePath = Left(FilePath, Q) & Mid(FilePath, K + 4)
            
            K = InStr(1, FilePath, "\..\")
        Loop
    End If
    
    AbsPath = FilePath
End Function
